# $Revision: 1.36.2.3 $, $Date: 2003/04/12 23:41:04 $
#
# Conditional build (--with/--without option)
#
# --with ggi		- with ggi video output
# --without sdl		- without SDL video/audio output
# --with gl		- with OpenGL video output
# --without vidix	- without vidix video output (x86 only)
# --with aalib		- with aalib video output
# --with alsa		- with ALSA support
# --with arts		- with aRts support
# --with esd		- with EsounD support
# --with mad		- with MAD support
# --without jpeg	- without JPEG input/output support
# --without png		- without PNG input/output support (enabled automatically for GUI)
# --with gif		- with GIF89a input/output support
# --with divx4linux	- with divx4linux support (DivX4Linux)
# --with xvid		- with xvid support
# --with lzo		- enable LZO codec
# --with faad2		- enable FAAD 2.x codec
# --without win32	- disable support for win32 codecs
# --without dshow	- disable DirectShow support
# --without qt		- disable support for QuickTime codecs
# --without xanim	- disable support for XAnim codecs
# --without real	- disable support for RealPlayer codecs
# --without vorbis	- without Ogg Vorbis support
# --with xmms		- with XMMS input plugins support
# --with cdparanoia	- support CDDA reading using cdparanoia
# --without mpdvdkit	- disable internal mpdvdkit
# --with lirc		- with lirc support
# --with dynamic_plugins- enable dynamic a/v plugins
# --without select	- disable audio select() support (ALSA and Vortex2 drivers require this option)
# --with menu		- enable OSD menu
# --without gui		- don't build gui gtk+ interface
# --without ft2		- without freetype2 fonts support for OSD and subtitles
# --with k6		- build K6-optimized package as i586 arch
# --with debug		- enable full debugging info

%define _with_gl		1
%define _with_arts		1
%define _with_esd		1
%define _without_vorbis		1
%define _with_menu		1


%define name mplayer
%define fname MPlayer
%define ver 1.0pre2
%define cvsbuild 20031007

%define release b1

%define cvs 0

%if%{cvs}
%define version %{ver}.%{cvsbuild}
%define fversion %{cvsbuild}
%else
%define version %{ver}
%define fversion %{ver}
%endif

%ifnarch %{ix86}
%define		_without_win32	1
%endif

%if%{!?_without_gui:1}%{?_without_gui:0}
%define		_with_png	1
%endif

%if%{?_without_win32:1}%{!?_without_win32:0}
%define		_without_dshow	1
%define		_without_qt	1
%endif

# The language to use in mplayer, one of : cz de dk en es fr hu nl no pl ro ru
%define	mplang		en

%define _win32_libdir	"/usr/lib/win32"
%define _xanim_libdir	"/usr/lib/xanim"
%define _real_libdir	"/usr/lib/real"

##%define _rh8x	%(grep -q "7." /etc/redhat-release ; echo $?)

Summary: MPlayer is a movie player for LINUX.
Name: %{name}
Version: %{version}
Release: %{release}%{?_with_k6:k6}%{?_with_debug:dbg}
Vendor: The MPlayer Project
URL: http://www.mplayerhq.hu
Group: Applications/Multimedia
Source0: http://www2.mplayerhq.hu/MPlayer/releases/%{fname}-%{fversion}.tar.bz2
Source1: gnome-%{name}.png
Source2: g%{name}.desktop
Source3: n019003l.pfb
Patch1: %{name}-rpm-cvs.patch
#Patch2: %{name}-rpm-release.patch
###Patch3: %{name}-nodebug.patch
###Patch4: %{name}-lavc.patch
#Patch5: %{name}-gui.patch
###Patch6: %{name}-warnings.patch
Patch7: %{name}-loader.patch
Patch8: %{name}-libmpdvdkit2.patch
###Patch9: %{name}-new-config.patch
###Patch10: %{name}-printf-format.patch
#Patch11: %{name}-20030218.patch
Copyright: GPL
Serial: 2
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArchitectures: i586

#%if %{_rh8x}
BuildRequires: gcc >= 3.1
#%else
#BuildRequires: gcc3 >= 3.1
#%endif

BuildRequires: XFree86-devel >= 4.0.3
####BuildRequires: libtermcap-devel
BuildRequires: audiofile-devel
BuildRequires: esound-devel
BuildRequires: zlib-devel
%{!?_without_sdl:BuildRequires:		SDL-devel >= 1.1.7}
%{?_with_gl:BuildRequires:		Mesa-devel}
%{?_with_ggi:BuildRequires:		libggi-devel}
%{?_with_aalib:BuildRequires:		aalib-devel}
%{!?_without_gui:BuildRequires:		gtk+-devel >= 1.2}
%{!?_without_jpeg:BuildRequires:	libjpeg-devel}
%{?_with_gif:BuildRequires:		libungif-devel}
%{!?_without_png:BuildRequires:		libpng-devel}
%{?_with_alsa:BuildRequires:		alsa-lib-devel}
%{?_with_arts:BuildRequires:		arts-devel}
%{?_with_esd:BuildRequires:		esound-devel}
%{?_with_divx4linux:BuildRequires:	divx4linux-devel >= 4}
%{?_with_xvid:BuildRequires:		xvid-static}
%{?_with_faad2:BuildRequires:		faad2-devel}
%{!?_without_vorbis:BuildRequires:	libvorbis-devel}
%{?_with_lirc:BuildRequires:		lirc-devel}
%{?_with_cdparanoia:BuildRequires:	cdparanoia-devel}
%{!?_without_ft2:BuildRequires:		freetype-devel >= 2.0.9}
%{?_with_xmms:BuildRequires:		xmms-devel}
#%{!?_without_win32:BuildRequires:	mplayer-codecs-win32}
#%{!?_without_real:BuildRequires:	mplayer-codecs-linux-real}
#%{!?_without_xanim:BuildRequires:	mplayer-codecs-linux-xanim}
Requires: %{name}-common = %{version}
Requires: XFree86-libs >= 4.0.3
%{!?_without_sdl:Requires: 	SDL >= 1.1.7}


%description
MPlayer is a movie and animation player that supports a wide range of file
formats, including AVI, MPEG, and Quicktime. It has many MMX/SSE/3Dnow
optimized native audio and video codecs, but allows using XAnim's and
RealPlayer's binary codec plugins, and Win32 codec DLLs. It has basic
VCD/DVD playback functionality, including DVD subtitles, but supports many
text-based subtitle formats too. For video output, nearly every existing
interface is supported. It's also able to convert any supported files to
raw/divx/mpeg4 AVI (pcm/mp3 audio), and even video grabbing from V4L
devices.

%package gui
Group: Applications/Multimedia
Summary: MPlayer with GUI interface
Provides: %{name} = %{version}
Requires: %{name}-skin
Requires: %{name}-common = %{version}

%description gui
MPlayer is a movie and animation player that supports a wide range of file
formats, including AVI, MPEG, and Quicktime. It has many MMX/SSE/3Dnow
optimized native audio and video codecs, but allows using XAnim's and
RealPlayer's binary codec plugins, and Win32 codec DLLs. It has basic
VCD/DVD playback functionality, including DVD subtitles, but supports many
text-based subtitle formats too. For video output, nearly every existing
interface is supported. It's also able to convert any supported files to
raw/divx/mpeg4 AVI (pcm/mp3 audio), and even video grabbing from V4L
devices.

%package common
Group: Applications/Multimedia
Summary: Configuration files and documentation for mplayer.
Requires: %{name} = %{version}

%description common
Configuration files, man page and HTML documentation for mplayer.

%package -n mencoder
Group: Applications/Multimedia
Summary: MEncoder is a movie encoder for LINUX.
Requires: mplayer = %{version}

%description -n mencoder
MEncoder a movie encoder for LINUX and is a part of the MPlayer package.

%package tools
Group: Applications/Multimedia
Summary: Various tools for the MPlayer
BuildRequires: freetype-devel >= 2.0.9
Requires: mplayer

%description tools
Various optional tools for use with MPlayer.

Currently included:
* mplayer_subfont	a tool for creating OSD fonts

%package vidix
Group: Applications/Multimedia
Summary: VIDeo Interface for *nIX
Requires: mplayer
Requires: mplayer-vidix-driver

%description vidix
VIDIX is the abbreviation for VIDeo Interface for *niX.
VIDIX was designed and introduced as an interface for fast user-space
drivers providing DGA everywhere where it's possible (unlike X11).
I hope that these drivers will be as portable as X11 (not only on *nix).
* What is it: It's a portable successor of mga_vid technology, but it's
  located in user-space.
* Unlike X11 it provides DGA everywhere it's possible
* Unlike v4l it provides interface for video playback
* Unlike linux's drivers it uses the math library

%package vidix-trident
Group: Applications/Multimedia
Summary: VIDIX driver for Trident Cyberblade i1
Provides: mplayer-vidix-driver

%description vidix-trident
VIDIX driver for Trident Cyberblade i1.

%package vidix-mach64
Group: Applications/Multimedia
Summary: VIDIX driver for ATI Mach64
Provides: mplayer-vidix-driver

%description vidix-mach64
VIDIX driver for ATI Mach64.

%package vidix-mga
Group: Applications/Multimedia
Summary: VIDIX drivers for Matrox Gxxx series
Provides: mplayer-vidix-driver

%description vidix-mga
Two VIDIX drivers for Matrox Gxxx series (using BES and CRTC2).

%package vidix-permedia
Group: Applications/Multimedia
Summary: VIDIX driver for 3DLabs Permedia3 cards
Provides: mplayer-vidix-driver

%description vidix-permedia
VIDIX driver for 3DLabs GLINT R3/Permedia3 driver.

%package vidix-radeon
Group: Applications/Multimedia
Summary: VIDIX driver for ATI Radeon
Provides: mplayer-vidix-driver

%description vidix-radeon
VIDIX driver for ATI Radeon.

%package vidix-rage128
Group: Applications/Multimedia
Summary: VIDIX driver for ATI Rage128
Provides: mplayer-vidix-driver

%description vidix-rage128
VIDIX driver for ATI Rage128.


%prep
%setup -q -n %{fname}-%{fversion}
%if%{cvs}
%patch1 -p1 -b .r
%else
#%patch2 -p1 -b .r
%endif
###%patch3 -p1 -b .nodebug
###%patch4 -p1 -b .lavc
#%{!?_without_gui:%patch5 -p1 -b .gui}
###%patch6 -p1 -b .warn
%patch7 -p1 -b .loader
%patch8 -p1 -b .mpdvdkit2
###%patch9 -p1 -b .ncfg
###%patch10 -p1 -b .printf
#%patch11 -p1 -b .cvs

%build
%if %{!?_with_debug:1}%{?_with_debug:0}
%ifarch i586
%{?_with_k6:RPM_OPT_FLAGS="-O2 -march=k6"}
%endif
# this is equivalent to -O3
CFLAGS="-Wall -Wno-unused-variable -Wno-unused-function -Wno-unused-label -Wno-uninitialized -Wno-multichar"
#" -W -Wfloat-equal"
CFLAGS="$CFLAGS $RPM_OPT_FLAGS -fomit-frame-pointer -ffast-math -finline-functions -frename-registers"
%ifnarch mips
CFLAGS="$CFLAGS -pipe"
%endif
export CFLAGS
%endif
LC_MESSAGES=C ; export LC_MESSAGES

# build GUI version
%if %{!?_without_gui:1}%{?_without_gui:0}
./configure \
			--prefix=%{_prefix} \
			--bindir=%{_bindir} \
			--datadir=%{_datadir}/%{name} \
			--mandir=%{_mandir} \
			--confdir=%{_sysconfdir}/%{name} \
			--language=%{mplang} \
%{?_with_debug:		--enable-debug=3} \
%ifarch i386
			--enable-runtime-cpudetection \
%endif
			--enable-largefiles \
			--enable-mga \
		        --enable-xmga \
		        --enable-tdfxfb \
			--enable-gui \
%{!?_with_aalib:	--disable-aa} \
%{!?_with_alsa:		--disable-alsa} \
%{!?_with_arts:		--disable-arts} \
%{!?_with_cdparanoia:	--disable-cdparanoia} \
%{!?_with_divx4linux:	--disable-divx4linux} \
%{?_without_dshow:	--disable-dshow} \
%{?_with_dynamic_plugins:	--enable-dynamic-plugins} \
%{!?_with_esd:		--disable-esd} \
%{?_with_faad2:		--enable-faad2} \
%{?_without_ft2:	--disable-freetype} \
%{!?_with_ggi:		--disable-ggi} \
%{!?_with_gif:		--disable-gif} \
%{!?_with_gl:		--disable-gl} \
%{?_without_jpeg:	--disable-jpeg} \
%{!?_with_lirc:		--disable-lirc} \
%{!?_with_lzo:		--disable-liblzo} \
%{!?_with_mad:		--disable-mad} \
%{?_with_menu:		--enable-menu} \
%{?_without_mpdvdkit:	--disable-mpdvdkit} \
%{?_without_qt:		--disable-qtx-codecs} \
%{?_without_real:	--disable-real} \
%{!?_without_real:	--with-reallibdir=%{_real_libdir}} \
%{?_without_sdl:	--disable-sdl} \
%{?_without_select:	--disable-select} \
%{?_without_vidix:	--disable-vidix} \
%{?_without_vorbis:	--disable-vorbis} \
%{?_without_win32:	--disable-win32} \
%{!?_without_win32:	--with-win32libdir=%{_win32_libdir}} \
%{?_without_xanim:	--disable-xanim} \
%{!?_without_xanim:	--with-xanimlibdir=%{_xanim_libdir}} \
%{?_with_xmms:		--enable-xmms} \
%{!?_with_xvid:		--disable-xvid}

%{__make}
mv -f mplayer gmplayer
%{__make} clean

echo Here be dragonz warning

%endif

# now build regular version
./configure \
			--prefix=%{_prefix} \
			--bindir=%{_bindir} \
			--datadir=%{_datadir}/%{name} \
			--mandir=%{_mandir} \
			--confdir=%{_sysconfdir}/%{name} \
			--language=%{mplang} \
%{?_with_debug:		--enable-debug=3} \
			--enable-largefiles \
%ifarch i386
			--enable-runtime-cpudetection \
%endif
			--enable-mga \
		        --enable-xmga \
		        --enable-tdfxfb \
%{!?_with_aalib:	--disable-aa} \
%{!?_with_alsa:		--disable-alsa} \
%{!?_with_arts:		--disable-arts} \
%{!?_with_cdparanoia:	--disable-cdparanoia} \
%{!?_with_divx4linux:	--disable-divx4linux} \
%{?_without_dshow:	--disable-dshow} \
%{?_with_dynamic_plugins:	--enable-dynamic-plugins} \
%{!?_with_esd:		--disable-esd} \
%{?_with_faad2:		--enable-faad2} \
%{?_without_ft2:	--disable-freetype} \
%{!?_with_ggi:		--disable-ggi} \
%{!?_with_gif:		--disable-gif} \
%{!?_with_gl:		--disable-gl} \
%{?_without_jpeg:	--disable-jpeg} \
%{!?_with_lirc:		--disable-lirc} \
%{!?_with_lzo:		--disable-liblzo} \
%{!?_with_mad:		--disable-mad} \
%{?_with_menu:		--enable-menu} \
%{?_without_mpdvdkit:	--disable-mpdvdkit} \
%{?_without_png:	--disable-png} \
%{?_without_qt:		--disable-qtx-codecs} \
%{?_without_real:	--disable-real} \
%{!?_without_real:	--with-reallibdir=%{_real_libdir}} \
%{?_without_sdl:	--disable-sdl} \
%{?_without_select:	--disable-select} \
%{?_without_vidix:	--disable-vidix} \
%{?_without_vorbis:	--disable-vorbis} \
%{?_without_win32:	--disable-win32} \
%{!?_without_win32:	--with-win32libdir=%{_win32_libdir}} \
%{?_without_xanim:	--disable-xanim} \
%{!?_without_xanim:	--with-xanimlibdir=%{_xanim_libdir}} \
%{?_with_xmms:		--enable-xmms} \
%{!?_with_xvid:		--disable-xvid}

%{__make}

pushd TOOLS/subfont-c
make
popd

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
find . -name CVS | xargs rm -rf
make \
	DESTDIR=$RPM_BUILD_ROOT \
	install

# install configs
install -d $RPM_BUILD_ROOT{%{_datadir}/%{name},%{_sysconfdir}/%{name}}
sed -e 's/include =.*//' < etc/example.conf | sed -e 's/fs=yes/# fs=yes/' | sed -e 's/# vo=xv/vo=xv/' >$RPM_BUILD_ROOT%{_sysconfdir}/%{name}/mplayer.conf
install -m 644 etc/codecs.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/
install -m 644 etc/input.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/
%if%{?_with_menu:1}%{!?_with_menu:0}
install -m 644 etc/menu.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/
%endif

# default font placeholder
touch $RPM_BUILD_ROOT%{_datadir}/%{name}/font

# install default Type1 font for subtitles
install %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/%{name}/subfont.ttf

# install tools
pushd TOOLS/subfont-c
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}/fonts/{osd,encodings}
install osd/* $RPM_BUILD_ROOT%{_datadir}/%{name}/fonts/osd/
install encodings/* $RPM_BUILD_ROOT%{_datadir}/%{name}/fonts/encodings/
install -m 755 subfont $RPM_BUILD_ROOT%{_bindir}/mplayer_subfont
popd

# cleanup CVS stuff
rm -rf DOCS/*/CVS

# add mencoder.1 man-link
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/mencoder.1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/man1/mencoder.1

# install international manpages and man-links
install -d $RPM_BUILD_ROOT%{_mandir}/{de,pl,hu,fr,zh_CN}/man1
mv DOCS/de/mplayer.1 $RPM_BUILD_ROOT%{_mandir}/de/man1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/de/man1/mencoder.1
mv DOCS/fr/mplayer.1 $RPM_BUILD_ROOT%{_mandir}/fr/man1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/fr/man1/mencoder.1
mv DOCS/hu/mplayer.1 $RPM_BUILD_ROOT%{_mandir}/hu/man1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/hu/man1/mencoder.1
mv DOCS/pl/mplayer.1 $RPM_BUILD_ROOT%{_mandir}/pl/man1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/pl/man1/mencoder.1
mv DOCS/zh/mplayer.1 $RPM_BUILD_ROOT%{_mandir}/zh_CN/man1
echo ".so mplayer.1" > $RPM_BUILD_ROOT%{_mandir}/zh_CN/man1/mencoder.1

# include skin, icon and menu entry if building with GUI
%if%{!?_without_gui:1}%{?_without_gui:0}
install -m 755 g%{name} $RPM_BUILD_ROOT%{_bindir}/
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/X11/applnk/Multimedia,%{_datadir}/pixmaps}
install %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/pixmaps/
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Multimedia/
%endif

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post vidix -p /sbin/ldconfig

%postun vidix -p /sbin/ldconfig

%files
%attr(755,root,root) %{_bindir}/mplayer

%if%{!?_without_gui:1}%{?_without_gui:0}
%files gui
%defattr(0644,root,root,0755)
%attr(755,root,root) %{_bindir}/gmplayer
%{_datadir}/pixmaps/gnome-%{name}.png
%{_sysconfdir}/X11/applnk/Multimedia/gmplayer.desktop
%endif

%files common
%defattr(0644,root,root,0755)
%config %{_sysconfdir}/%{name}/codecs.conf
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/%{name}/mplayer.conf
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/%{name}/input.conf
%if%{?_with_menu:1}%{!?_with_menu:0}
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/%{name}/menu.conf
%endif
##%doc DOCS/*.html
##%lang(de) %doc %dir DOCS/German
###%lang(es) %doc %dir DOCS/Spanish
##%lang(fr) %doc %dir DOCS/French
##%lang(hu) %doc %dir DOCS/Hungarian
##%lang(it) %doc %dir DOCS/Italian
##%lang(pl) %doc %dir DOCS/Polish
###%lang(ru) %doc %dir DOCS/Russian
##%lang(zh_CN) %doc %dir DOCS/Chinese
%{_mandir}/man1/*
%lang(de) %{_mandir}/de/man1/*
%lang(fr) %{_mandir}/fr/man1/*
%lang(hu) %{_mandir}/hu/man1/*
%lang(pl) %{_mandir}/pl/man1/*
%lang(zh_CN) %{_mandir}/zh_CN/man1/*
%dir %{_prefix}/share/mplayer
%ghost %{_prefix}/share/mplayer/font
%{_prefix}/share/mplayer/subfont.ttf

%files -n mencoder
%defattr(0644,root,root,0755)
%attr(755,root,root) %{_bindir}/mencoder

%files tools
%defattr(0644,root,root,0755)
%attr(755,root,root) %{_bindir}/mplayer_subfont
%attr(755,root,root) %{_datadir}/%{name}/fonts/osd/gen.py
%{_datadir}/%{name}/fonts/osd/osd.pfb
%{_datadir}/%{name}/fonts/osd/README
%attr(755,root,root) %{_datadir}/%{name}/fonts/osd/runme
%attr(755,root,root) %{_datadir}/%{name}/fonts/encodings/charmap2enc
%{_datadir}/%{name}/fonts/encodings/osd-mplayer
%attr(755,root,root) %{_datadir}/%{name}/fonts/encodings/runme-kr

%if%{?_without_vidix:0}%{!?_without_vidix:1}
%files vidix
%defattr(0644,root,root,0755)
%attr(755,root,root) %{_libdir}/libdha.so.*
%dir %{_libdir}/mplayer/vidix

%files vidix-trident
%attr(755,root,root) %{_libdir}/%{name}/vidix/cyberblade_vid.so

%files vidix-mach64
%attr(755,root,root) %{_libdir}/%{name}/vidix/mach64_vid.so

%files vidix-mga
%attr(755,root,root) %{_libdir}/%{name}/vidix/mga_crtc2_vid.so
%attr(755,root,root) %{_libdir}/%{name}/vidix/mga_vid.so

%files vidix-permedia
%attr(755,root,root) %{_libdir}/%{name}/vidix/pm3_vid.so

%files vidix-radeon
%attr(755,root,root) %{_libdir}/%{name}/vidix/radeon_vid.so

%files vidix-rage128
%attr(755,root,root) %{_libdir}/%{name}/vidix/rage128_vid.so
%endif


##
## Change log
##

%changelog
* Wed Oct 8 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to 1.0pre2
* Fri Sep 5 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to 1.0pre1
* Fri Aug 15 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Version Up to 0.91
* Fri Apr 25 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
- from MPLAYERHQ.HU
- mplayer-0.90-1.src.rpm
